Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/trunk/install.sh
ViewVC logotype

Diff of /config/trunk/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 691, Tue Jul 25 07:20:24 2000 UTC revision 1747, Fri Jan 14 23:53:21 2005 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/sh
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4    # Copyright (c) 2003 The Fellowship of SML/NJ
5  #  #
6  # Installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
7  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
8  #  #
9  # Significant changes to accommodate (and take advantage of) the new CM  # Significant changes to take advantage of a new portable installer
10  # by M.Blume (2/2000).  # script for everything after booting the interactive system.
11    #
12    # Author: Matthias Blume (blume@tti-c.org)
13  #  #
14    
15  this=$0  if [ x${INSTALL_QUIETLY} = xtrue ] ; then
16        export CM_VERBOSE
17        CM_VERBOSE=false
18    fi
19    
20  #  vsay() {
21  # get the target list      if [ x${INSTALL_DEBUG} = xtrue ] ; then
22  #          echo "$@"
23  if [ ! -r config/targets ]; then      elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
24      echo "$this: !!! File config/targets is missing."          :
25      exit 1      else
26            echo "$@"
27  fi  fi
28  . config/targets  }
29    
30    complain() {
31        echo "$@"
32        exit 1
33    }
34    
35    this=$0
36    
37    
38  #  #
39  # create the preloads.standard file  # create the preloads.standard file
40  #  #
41  if [ ! -r config/preloads ]; then  if [ ! -r config/preloads ]; then
42      echo "$this: !!! File config/preloads is missing."      complain "$this: !!! File config/preloads is missing."
     exit 1  
43  fi  fi
44  cp config/preloads preloads.standard  cp config/preloads preloads.standard
45    
# Line 36  Line 50 
50  MAKE=make  MAKE=make
51    
52  SHELL=/bin/sh  SHELL=/bin/sh
53  echo $this: Using shell $SHELL.  vsay $this: Using shell $SHELL.
54    
55  #  #
56  # set the SML root directory  # set the SML root directory
57  #  #
58  REAL_PWD=`pwd`  REAL_PWD=`pwd`
59  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
60  echo $this: SML root is $ROOT.  vsay $this: SML root is $ROOT.
61  echo $this: Installation directory is ${INSTALLDIR:=$ROOT}.  
62    cd "${INSTALLDIR:=$ROOT}"
63    INSTALLDIR=`pwd`
64    cd "$ROOT"
65    vsay $this: Installation directory is ${INSTALLDIR}.
66    
67  #  #
68  # set the various directory and file pathname variables  # set the various directory and file pathname variables
# Line 55  Line 73 
73  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
74  SRCDIR=$ROOT/src                # where the source tree is rooted  SRCDIR=$ROOT/src                # where the source tree is rooted
75  LIBDIR=$INSTALLDIR/lib          # where libraries live  LIBDIR=$INSTALLDIR/lib          # where libraries live
 LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries  
 LIBMOVESCRIPT=$ROOT/libmove     # a temporary script  
 LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file  
   
 URLGETTER=unknown  
   
 #  
 # the path to the dir where ml-yacc, ml-burg, ml-lex, ml-build, and  
 # ml-makedepend live  
 #  
 TOOLDIR=$BINDIR  
   
 #  
 # A temporary file for post-editing the pathconfig file...  
 #  
 PCEDITTMP=/usr/tmp/pcedittmp.$$  
76    
77  #  #
78  # files to be deleted after we are done...  # files to be deleted after we are done...
79  #  #
80  tmpfiles=""  tmpfiles=""
81  tmpfiles="$tmpfiles $ROOT/preloads.standard"  tmpfiles="$tmpfiles preloads.standard"
 tmpfiles="$tmpfiles $LIBLIST"  
 tmpfiles="$tmpfiles $LOCALPATHCONFIG"  
 tmpfiles="$tmpfiles $LIBMOVESCRIPT"  
 tmpfiles="$tmpfiles $PCEDITTMP"  
82  #  #
83  # make sure we always clean up after ourselves...  # make sure we always clean up after ourselves...
84  #  #
85  trap 'rm -f $tmpfiles' 0 1 2 3 15  trap 'cd "$ROOT"; rm -f $tmpfiles' 0 1 2 3 15
86    
87    
88  #  #
89  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
90  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
91  # Especially important is CM_PATHCONFIG_DEFAULT.  # Especially important is CM_PATHCONFIG.
92  #  #
93  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig  export CM_PATHCONFIG
94  export CM_PATHCONFIG_DEFAULT  CM_PATHCONFIG=$LIBDIR/pathconfig
95    
96  #  #
97  # the release version that we are installing  # the release version that we are installing
98  #  #
99  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat "$CONFIGDIR/version"`
100  echo $this: Installing version $VERSION.  vsay $this: Installing version $VERSION.
101    
102  #  #
103  # the URL for the (usually remote) source archive  # the URL for the (usually remote) source archive
104  #  #
105  SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`  . "$CONFIGDIR"/srcarchiveurl
106  echo $this: URL of source archive is $SRCARCHIVEURL.  vsay $this: URL of source archive is $SRCARCHIVEURL.
107    
108  #  #
109  # Function to make a directory (and advertise such action).  # Function to make a directory including its ancestors.
110  #  #
111  makedir() {  makedir() {
112      if [ ! -d $1 ] ; then      if [ x"$1" = x ] ; then
113          echo $this: Making directory $1          :
114          if mkdir $1 ; then      elif [ -d "$1" ] ; then
115              : everything is fine          :
116          else          else
117              echo "$this: !!! Unable to make directory $1!"          makedirtmp=`dirname "$1"`
118              exit 1          makedir "$makedirtmp"
119          fi          if [ x${INSTALL_VERBOSE} = xtrue ] ; then
120                vsay "$this: Making directory $1"
121      fi      fi
122  }          if mkdir "$1" ; then
123                :
 #  
 # Function for asking user to fetch source archive.  
 #   $1 - descriptive name  
 #   $2 - base name without extension, without version, and without dir  
 #   $3 - remote directory  
 #  
 askurl() {  
     echo "$this: Please, fetch $1 archive"  
     echo ' ('$2.'*' or $VERSION-$2.'*)'  
     echo " from $3"  
     echo " and then re-run this script!"  
     exit 1  
 }  
   
 #  
 # Function for fetching source archives automatically using wget or lynx.  
 #   $1 - command to actually get the stuff  
 #   $2 - descriptive name  
 #   $3 - base name without extension and without dir  
 #   $4 - remote directory  
 #  
 fetchurl() {  
     getter=$1 ; shift  
     echo $this: Fetching $1 from $3. Please stand by...  
     fetched=no  
     for base in $2 $VERSION-$2 ; do  
         for ext in tar.gz tgz tar.Z tz tar tar.bz2 ; do  
             try=$base.$ext  
             echo $this: Trying $try ...  
             if $getter $3 $try $ROOT/$try ; then  
                 fetched=yes  
                 echo $this: Fetching $try was a success.  
                 break 2         # get out of both for-loops  
124              else              else
125                  rm -f $ROOT/$try              complain "$this: !!! Unable to make directory $1!"
126              fi              fi
         done  
     done  
     if [ $fetched = no ] ; then  
         echo $this: Fetching $try was no success.  
         echo '  ' You should try to do it manually now.  
         askurl "$1" "$2" "$3"  
127      fi      fi
128  }  }
129    
 usewget() {  
     wget -nv -O $3 $1/$2  
 }  
   
 uselynx() {  
     lynx -source $1/$2 >$3  
 }  
   
 testurlgetter() {  
     (exec >/dev/null 2>&1 ; exec $*)  
 }  
   
130  #  #
131  # Function to check whether wget or lynx is available.  # Fish out the CM metadata directory name from library files
132  # Set URLGETTER accordingly.  # and store it in ORIG_CM_DIR_ARC.
133    # The single argument is the name of the directory containing
134    # a single subdirectory which is a CM metadata directory:
135  #  #
136  urlgetter() {  fish() {
137      if [ "$URLGETTER" = unknown ] ; then      cd "$1"
138          if testurlgetter wget --help ; then      ORIG_CM_DIR_ARC=unknown
139              URLGETTER="fetchurl usewget"      for i in * .[a-zA-Z0-9]* ; do
140          elif testurlgetter lynx -help ; then          if [ -d $i ] ; then
141              URLGETTER="fetchurl uselynx"              ORIG_CM_DIR_ARC=$i
142          else              break
             URLGETTER="askurl"  
         fi  
143      fi      fi
144  }      done
145        if [ $ORIG_CM_DIR_ARC = unknown ] ; then
146  un_tar() {          complain "$this: could not determine CM metadata directory name"
     echo "$this: Un-TAR-ing $1 archive."  
     tar -xf $2  
 }  
   
 un_tar_Z() {  
     echo "$this: Un-COMPRESS-ing and un-TAR-ing $1 archive."  
     zcat $2 | tar -xf -  
 }  
   
 un_tar_gz() {  
     echo "$this: Un-GZIP-ing and un-TAR-ing $1 archive."  
     gunzip -c $2 | tar -xf -  
 }  
   
 un_tar_bz2() {  
     echo "$this: Un-BZIP2-ing and un-TAR-ing $1 archive."  
     bunzip2 -c $2 | tar -xf -  
 }  
   
 unarchive() {  
     # $1: descriptive string, $2: archive, $3: unpacker  
     if [ -r $ROOT/$2 ] ; then  
         $3 "$1" $ROOT/$2  
     elif [ -r $ROOT/$VERSION-$2 ]; then  
         $3 "$1" $ROOT/$VERSION-$2  
147      else      else
148          return 1          echo "$this: CM metadata directory name is \"${ORIG_CM_DIR_ARC}\""
149      fi      fi
150  }  }
151    
 #  
 # Function to unpack a source archive.  
 #  
 # $1: descriptive name of the sources to be unpacked  
 # $2: the directory into which to unpack the sources  
 # $3: the sub-directory of $2 that is going to be created by unpacking  
 # $4: the basename of the source archive (the script will check several  
 #     different suffixes to determine what kind of de-compression is to  
 #     be used)  
 #  
 # fetch_n_unpack is the helper function that does the real work.  If  
 # no archive is found locally, it invokes $URLGETTER and tries again.  
 # The variable $tryfetch is used to make sure this happens only once.  
 fetch_n_unpack() {  
     cd $2  
     if unarchive "$1" $4.tar.gz un_tar_gz ||  
        unarchive "$1" $4.tgz un_tar_gz ||  
        unarchive "$1" $4.tar.Z un_tar_Z ||  
        unarchive "$1" $4.tar un_tar ||  
        unarchive "$1" $4.tar.bz1 un_tar_bz2 ||  
        unarchive "$1" $4.tz un_tar_Z  
     then  
         : we are done  
     elif [ $tryfetch = yes ] ; then  
         urlgetter  
         $URLGETTER "$1" $4 $SRCARCHIVEURL  
         tryfetch=no  
         fetch_n_unpack "$1" "$2" "$3" "$4"  
     fi  
 }  
   
 #  
 # The main "unpack" driver function that invokes the above helper.  
 #  
 unpack() {  
     tryfetch=yes  
     if [ -d $2/$3 ]; then  
         echo "$this: The $1 tree already exists."  
     else  
         fetch_n_unpack "$1" "$2" "$3" "$4"  
     fi  
     if [ ! -d $2/$3 ]; then  
         echo "$this: !!! Unable to unpack $1 archive."  
         exit 1  
     fi  
 }  
152    
153  # A function to move all stable library files to a parallel directory  # A function to move all stable library files to a parallel directory
154  # hierarchy.  # hierarchy.
155  # The first argument must be a simple path (no / inside), and  # The first argument must be a simple path (no / inside), and
156  # the second argument must be an absolute path.  # the second argument must be an absolute path.
157  move() {  move() {
158      if [ -d $1 ] ; then      if [ -L "$1" ] ; then
159          if [ ! -d $2 ] ; then          rm -f "$1"           # remove symbolic link made by diracs (see below)
160              if [ -f $2 ] ; then      elif [ -d "$1" ] ; then
161                  echo $this: $2 exists as a non-directory.          if [ ! -d "$2" ] ; then
162                  exit 1              if [ -f "$2" ] ; then
163              fi                  complain $this: $2 exists as a non-directory.
164              mkdir $2              fi
165          fi              mkdir "$2"
166          cd $1          fi
167          for i in * ; do          cd "$1"
168              move $i $2/$i          for i in * .[a-zA-Z0-9]* ; do
169                move "$i" "$2"/"$i"
170          done          done
171          cd ..          cd ..
172      elif [ -f $1 ] ; then      elif [ -f "$1" ] ; then
173          rm -f $2          rm -f "$2"
174          mv $1 $2          mv "$1" "$2"
175      fi      fi
176  }  }
177    
178  #  #
179  # Move the stable archive of a library whose description file was $1/$2 to  # Traverse the directory tree rooted at $3 (must be single arc!).
180  # $LIBDIR/$2/CM/$ARCH-unix/$2 so that it appears as if the description file  # Find all directories named $1, rename them into $2 and make
181  # had been at $LIBDIR/$2/$2  # and establish $1 as a symbolic link to $2:
 #  
 # (This script will also move all other libraries that show up in  
 #  $1/CM/$ARCH-unix because in the case of the boot directory this indicates  
 #  that some library did not have its own path anchor but was specified  
 #  relative to $1/$2. Still, don't rely on this to be robust -- rather make  
 #  separate anchors for every library!)  
 #  
 movelibs() {  
     for lib in `/bin/ls $1/CM/$ARCH-unix` ; do  
         case $lib in  
         *.cm | *.cmi)  
             if [ $lib != $2 ] ; then  
                 echo "$this: Warning:" $lib specified relative to $2  
             fi  
             echo $this: Moving library $lib to $LIBDIR  
             makedir $LIBDIR/$2  
             makedir $LIBDIR/$2/CM  
             makedir $LIBDIR/$2/CM/$ARCH-unix  
             mv $1/CM/$ARCH-unix/$lib $LIBDIR/$2/CM/$ARCH-unix/$lib  
             ;;  
         *)  
             ;;  
         esac  
      done  
 }  
   
 # A shell function that registers a library for being built.  
 # This function takes two arguments: 1. a name under which the library  
 # is to be known later (something.cm) and 2. the path relative to $SRCDIR  
 # that leads to the library's .cm file.  The library's .cm file must be the  
 # same as $1.  
 #  
 # This works by adding ML code to file $LIBLIST.  The code in this file  
 # will be executed near the end of this script.  If $MOVE_LIBRARIES is  
 # set to true, then reglib will also register a "movelibs" to be executed at  
 # the end by putting a "movelibs" line into $LIBMOVESCRIPT.  
   
 reglib() {  
     if [ x$MOVE_LIBRARIES = xtrue ] ; then  
         FINALLOCATION=$LIBDIR/$1  
         FINALCONFIGPATH=$1  
     else  
         FINALLOCATION=$SRCDIR/$2  
         FINALCONFIGPATH=$FINALLOCATION  
     fi  
     if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then  
         echo "$this: Library $1 already exists in $FINALLOCATION."  
     else  
         echo "$this: Scheduling library $1 to be built in $FINALLOCATION."  
         echo "  andalso CM.stabilize false \"\$/$1\"" >>$LIBLIST  
         echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG  
         if [ x$MOVE_LIBRARIES = xtrue ] ; then  
             echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT  
         fi  
     fi  
     echo $1 $FINALCONFIGPATH >>$CM_PATHCONFIG_DEFAULT  
 }  
   
182  #  #
183  # Function to build a standalone program such as ml-yacc.  The function takes  dirarcs() {
184  # 2 or 3 arguments.  First the name of the program which at the same time      if [ -d "$3" ] ; then
185  # is the directory name under $SRCDIR where the sources reside.  The second          if [ "$3" = "$1" ] ; then
186  # argument is a descriptive name for the program (passed on to "unpack").              mv "$1" "$2"
187  # The optional third argument specifies the path relative to $SRCDIR/$1              ln -s "$2" "$1"
 # of the directory where the program's heap image is to be found.  
 #  
   
 standalone() {  
     TARGET=$1.$HEAP_SUFFIX  
     if [ $# = 3 ] ; then  
         TARGETLOC=$3/$TARGET  
     else  
         TARGETLOC=$TARGET  
     fi  
     if [ -r $HEAPDIR/$TARGET ] ; then  
         echo $this: Target $TARGET already exists.  
     else  
         echo $this: Building $TARGET.  
         unpack $2 $SRCDIR $1 $1  
         cd $SRCDIR/$1  
         ./build  
         if [ -r $TARGETLOC ] ; then  
             mv $TARGETLOC $HEAPDIR/$TARGET  
             if [ ! -f $BINDIR/$1 ] ; then  
                 cd $BINDIR  
                 ln -s .run-sml $1  
             fi  
188          else          else
189              echo "$this: !!! Build of $TARGET failed."              cd "$3"
190                for d in * .[a-zA-Z0-9]* ; do
191                    dirarcs "$1" "$2" "$d"
192                done
193                cd ..
194          fi          fi
195      fi      fi
196  }  }
197    
198    
199    ######################################################################
200    
201  #  #
202  # create the various sub directories  # create the various sub directories
203  #  #
204  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do  for dir in "$BINDIR" "$HEAPDIR" "$RUNDIR" "$LIBDIR" "$SRCDIR" ; do
205      makedir $dir      makedir "$dir"
206  done  done
207    
208  #  #
 # install the script that tests the architecture, and make sure that it works  
 #  
 if [ -x $BINDIR/.arch-n-opsys ]; then  
     echo $this: Script $BINDIR/.arch-n-opsys already exists.  
 else  
     cat $CONFIGDIR/_arch-n-opsys \  
     | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys  
     chmod 555 $BINDIR/.arch-n-opsys  
     if [ ! -x $BINDIR/.arch-n-opsys ]; then  
         echo "$this: !!! Installation of $BINDIR/.arch-n-opsys failed."  
         exit 1  
     fi  
 fi  
   
 ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  
 if [ "$?" != "0" ]; then  
     echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."  
     echo "$this: !!! You must patch this by hand and repeat the installation."  
     exit 2  
 else  
     echo $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.  
 fi  
 eval $ARCH_N_OPSYS  
   
 #  
209  # Function to install a "driver" script...  # Function to install a "driver" script...
210  #   This takes care of patching the source of the script with the SHELL,  #   This takes care of patching the source of the script with the SHELL,
211  #   BINDIR, and VERSION variables to use.  #   BINDIR, and VERSION variables to use.
# Line 440  Line 219 
219  #   if [ -x $BINDIR/$ddst ]; then  #   if [ -x $BINDIR/$ddst ]; then
220  #       echo $this: Script $BINDIR/$ddst already exists.  #       echo $this: Script $BINDIR/$ddst already exists.
221  #   else  #   else
222          rm -f $BINDIR/$ddst          rm -f "$BINDIR"/"$ddst"
223          cat $CONFIGDIR/$dsrc | \          cat "$CONFIGDIR"/"$dsrc" | \
224          sed -e "s,@SHELL@,$SHELL,g" \          sed -e "s,@SHELL@,$SHELL,g" \
225              -e "s,@BINDIR@,$BINDIR," \              -e "s,@BINDIR@,$BINDIR," \
226              -e "s,@VERSION@,$VERSION," \              -e "s,@VERSION@,$VERSION," \
227              > $BINDIR/$ddst              -e "s,@CMDIRARC@,${CM_DIR_ARC:-dummy}," \
228          chmod 555 $BINDIR/$ddst              > "$BINDIR"/"$ddst"
229          if [ ! -x $BINDIR/$ddst ]; then          chmod 555 "$BINDIR"/"$ddst"
230              echo "$this: !!! Installation of $BINDIR/${ddst} failed."          if [ ! -x "$BINDIR"/"$ddst" ]; then
231              exit 1              complain "$this: !!! Installation of $BINDIR/${ddst} failed."
232          fi          fi
233  #   fi  #   fi
234  }  }
235    
236    #
237    # install the script that tests architecture and os...
238    #
239    installdriver _arch-n-opsys .arch-n-opsys
240    
241    #
242    # run it to figure out what architecture and os we are using, define
243    # corresponding variables...
244    #
245    ARCH_N_OPSYS=`"$BINDIR"/.arch-n-opsys`
246    if [ "$?" != "0" ]; then
247        echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
248        echo "$this: !!! You must patch this by hand and repeat the installation."
249        exit 2
250    else
251        vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
252    fi
253    eval $ARCH_N_OPSYS
254    
255    #
256    # now install most of the other driver scripts
257    #  (except ml-build, since we don't know $CM_DIR_ARC yet)
258    #
259  installdriver _run-sml .run-sml  installdriver _run-sml .run-sml
260  installdriver _link-sml .link-sml  installdriver _link-sml .link-sml
 installdriver _ml-build ml-build  
261  installdriver _ml-makedepend ml-makedepend  installdriver _ml-makedepend ml-makedepend
262    
263    installdriver _heap2exec heap2exec
264    
265  #  #
266  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
267  #  #
# Line 489  Line 292 
292      linux)      linux)
293          EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`          EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
294          if [ "$?" != "0" ]; then          if [ "$?" != "0" ]; then
295              echo "$this: !!! Problems checking for underscores in asm names."              complain "$this: !!! Problems checking for underscores in asm names."
             exit 1  
296          fi          fi
297          EXTRA_DEFS="XDEFS=$EXTRA_DEFS"          EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
298          ;;          ;;
# Line 505  Line 307 
307  #  #
308  # build the run-time system  # build the run-time system
309  #  #
310  unpack "run-time" $SRCDIR runtime runtime  if [ -x "$RUNDIR"/run.$ARCH-$OPSYS ]; then
311  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then      vsay $this: Run-time system already exists.
     echo $this: Run-time system already exists.  
312  else  else
313      cd $SRCDIR/runtime/objs      "$CONFIGDIR"/unpack "$ROOT" runtime
314        cd "$SRCDIR"/runtime/objs
315      echo $this: Compiling the run-time system.      echo $this: Compiling the run-time system.
316      $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS      $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
317      if [ -x run.$ARCH-$OPSYS ]; then      if [ -x run.$ARCH-$OPSYS ]; then
318          mv run.$ARCH-$OPSYS $RUNDIR          mv run.$ARCH-$OPSYS "$RUNDIR"
319          # $MAKE MAKE=$MAKE clean          if [ -f runx.$ARCH-$OPSYS ]; then
320                mv runx.$ARCH-$OPSYS "$RUNDIR"
321            fi
322            $MAKE MAKE=$MAKE clean
323      else      else
324          echo "$this: !!! Run-time system build failed for some reason."          complain "$this: !!! Run-time system build failed for some reason."
         exit 1  
325      fi      fi
326  fi  fi
327  cd $SRCDIR  cd "$SRCDIR"
328    
329  #  #
330  # boot the base SML system  # boot the base SML system
331  #  #
332  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r "$HEAPDIR"/sml.$HEAP_SUFFIX ]; then
333      echo $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
334        fish "$LIBDIR"/basis.cm
335        # ignore requested arc name since we have to live with what is there:
336        export CM_DIR_ARC
337        CM_DIR_ARC=$ORIG_CM_DIR_ARC
338    else
339        "$CONFIGDIR"/unpack "$ROOT" "$BOOT_ARCHIVE"
340    
341        fish "$ROOT"/"$BOOT_FILES"/basis.cm
342    
343        cd "$ROOT"
344    
345        # Target arc:
346        export CM_DIR_ARC
347        CM_DIR_ARC=${CM_DIR_ARC:-".cm"}
348    
349        if [ $CM_DIR_ARC = $ORIG_CM_DIR_ARC ] ; then
350            : we are happy
351  else  else
352      unpack bin $ROOT $BOOT_FILES $BOOT_ARCHIVE          # now we have to make a symbolic link for each occurrence of
353      cd $ROOT/$BOOT_FILES          # $ORIG_CM_DIR_ARC to $CM_DIR_ARC
354      if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC          dirarcs "$ORIG_CM_DIR_ARC" "$CM_DIR_ARC" "$BOOT_FILES"
355        fi
356    
357        cd "$ROOT"/"$BOOT_FILES"
358    
359        # now link (boot) the system and let it initialize itself...
360        if "$BINDIR"/.link-sml @SMLheap="$ROOT"/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
361      then      then
362          cd $ROOT          cd "$ROOT"
363          if [ -r sml.$HEAP_SUFFIX ]; then          if [ -r sml.$HEAP_SUFFIX ]; then
364              mv sml.$HEAP_SUFFIX $HEAPDIR              mv sml.$HEAP_SUFFIX "$HEAPDIR"
365              cd $BINDIR              cd "$BINDIR"
366              ln -s .run-sml sml              ln -s .run-sml sml
367              #              #
368              # Now move all stable libraries to #LIBDIR and generate              # Now move all stable libraries to #LIBDIR and generate
369              # the pathconfig file.              # the pathconfig file.
370              #              #
371              cd $ROOT/$BOOT_FILES              cd "$ROOT"/"$BOOT_FILES"
372              for anchor in * ; do              for anchor in * ; do
373                  if [ -d $anchor ] ; then                  if [ -d $anchor ] ; then
374                      echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT                      echo $anchor $anchor >>$CM_PATHCONFIG
375                      move $anchor $LIBDIR/$anchor                      move $anchor "$LIBDIR"/$anchor
376                  fi                  fi
377              done              done
378              cd $ROOT              cd "$ROOT"
379              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
380              rm -rf $BOOT_FILES              rm -rf "$BOOT_FILES"
381    
382          else          else
383              echo "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
             exit 1  
384          fi          fi
385      else      else
386          echo "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."          complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
         exit 1  
387      fi      fi
388  fi  fi
389    
390  #  #
391  # Initialize $LIBLIST  # now that we know CM_DIR_ARC we can install the ml-build driver...
392  #  #
393  cd $ROOT  installdriver _ml-build ml-build
 rm -f $LOCALPATHCONFIG $LIBLIST  
 echo 'ignore (OS.Process.exit (if true' >$LIBLIST  
   
 #  
 # now build (or prepare to build) the individual targets  
 #  
 cd $SRCDIR  
 echo $this: Installing other targets.  
 for i in $TARGETS ; do  
     case $i in  
       src-smlnj)  
         for src in compiler cm MLRISC smlnj-lib ml-yacc system  
         do  
             unpack $src $ROOT/src $src $src  
         done  
         ;;  
       ml-yacc)  
         standalone ml-yacc ML-Yacc src  
         echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG_DEFAULT  
         ;;  
       ml-lex)  
         standalone ml-lex ML-Lex  
         echo ml-lex $TOOLDIR >>$CM_PATHCONFIG_DEFAULT  
         ;;  
       ml-burg)  
         standalone ml-burg ML-Burg  
         echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT  
         ;;  
       smlnj-lib)  
         unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib  
394    
395          # Don't make the Util library -- it came pre-made and has been  cd "$ROOT"
         # installed when making the base system.  In other words, don't do...  
             #reglib smlnj-lib.cm smlnj-lib/Util  
         # ... and don't make the HTML library ...  
             #reglib html-lib.cm smlnj-lib/HTML  
         # ... and don't make the PP library ...  
             #reglib pp-lib.cm smlnj-lib/PP  
         # make the Unix library  
             reglib unix-lib.cm smlnj-lib/Unix  
         # make the INet library  
             reglib inet-lib.cm smlnj-lib/INet  
         # make the RegExp library  
             reglib regexp-lib.cm smlnj-lib/RegExp  
         # make the Reactive library  
             reglib reactive-lib.cm smlnj-lib/Reactive  
         ;;  
       cml)  
         unpack CML $SRCDIR cml cml  
         reglib core-cml.cm cml/src/core-cml  
         reglib cml.cm cml/src  
         reglib cml-basis.cm cml  
         ;;  
       cml-lib)  
         unpack CML $SRCDIR cml cml  
         reglib cml-lib.cm cml/cml-lib  
         ;;  
       eXene)  
         unpack EXene $SRCDIR eXene eXene  
         reglib eXene.cm eXene  
         ;;  
       doc)  
         unpack Doc $ROOT doc doc  
         cd $ROOT/doc  
         build $ROOT  
         ;;  
       *)  
         echo "$this: !!! Unknown target $i."  
         ;;  
     esac  
 done  
396    
397  #  #
398  # Now go and stabilize all registered libraries...  # Now do all the rest using the precompiled installer:
 # This is done with library sources in their original locations inside  
 # $SRCDIR, so we must consult $LOCALPATHCONFIG.  
399  #  #
400    echo $this: Installing other libraries and programs:
401  echo $this: Compiling library code.  export ROOT INSTALLDIR CONFIGDIR BINDIR
402  echo 'then OS.Process.success else OS.Process.failure));' >>$LIBLIST  if "$BINDIR"/sml -m \$smlnj/installer.cm
403  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then  then
404      echo $this: Libraries compiled successfully.      vsay $this: Installation complete.
405  else  else
406      echo "$this: !!! Something went wrong when compiling the libraries."      complain "$this: !!! Installation of libraries and programs failed."
     exit 1  
 fi  
   
 #  
 # Move the libraries to their final locations...  
 #  
   
 if [ -r $LIBMOVESCRIPT ] ; then  
     echo $this: Moving libraries to $LIBDIR.  
     . $LIBMOVESCRIPT  
 fi  
   
 #  
 # Finally, remove duplicate entries from pathconfig file...  
 #  
 if [ -f $CM_PATHCONFIG_DEFAULT ] ; then  
     cp $CM_PATHCONFIG_DEFAULT $PCEDITTMP  
     rm -f $CM_PATHCONFIG_DEFAULT  
     awk <$PCEDITTMP 'NF == 2 { mapping[$1] = $2 }  
 NF != 2 { print $0 }  
 END { for (i in mapping) print i, mapping[i] }' \  
       | sort >$CM_PATHCONFIG_DEFAULT  
407  fi  fi
408    
409  exit 0  exit 0

Legend:
Removed from v.691  
changed lines
  Added in v.1747

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0